//*****************************************
// Graphic LCD Serial(RS232) Terminal Program ATMega88
// CPU Clock:O9.216MHz(9.22)i3.3VPOlgȉȂ̂ł̂܂܂Ŏgj
//   iq[Yf[^@WȂŁAOUWlgȏɂj
//
// File Name:Timer.c
//
//  2014/03/28 New
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"Timer.h"
#include	"switch.h"


unsigned char	tim_1ms;						// 10mSPʂJE^[
unsigned char	tim_10ms;						// PbPʂJE^[
unsigned char	tim_10ms_led1;					// kdcPpPOrPʃ^C}[
unsigned char	tim_10ms_led2;					// kdcQpPOrPʃ^C}[
unsigned char	tim_1sec_clk;
unsigned char	tim_1min_clk;
unsigned char	tim_1hou_clk;

// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
// 8MHz-- 1mS Interrupt
//#define	COUNT_1MS		125										// 1mS at 8MHz/64 = 125kHz(8uS)
//#define	D_TCCR2B	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)

// 2.304MHz -- 10mS Interrupt
//#define	COUNT_10MS	90											// 10mS at 2.304MHz/256 = 9kHz 9kHz/90=100Hz(10mS)
//#define	D_TCCR2B	((1 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (2.304MHz/256 = 9kHz)

// 9.216MHz -- 10mS Interrupt
#define	COUNT_10MS	90											// 10mS at 9.216MHz/1024 = 9kHz 9kHz/90=100Hz(10mS)
#define	D_TCCR2B	((1 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (9.216MHz/1024 = 9kHz)

//*****************************************
// Timer2 Initial
//  10mS 荞݂ɐݒ肷
//*****************************************
void	Timer2_init(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal
	OCR2A  = COUNT_10MS;								// 10mS
	TCCR2B = D_TCCR2B;									// Timer Start
	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable

//	tim_1ms = 10;										// 10mSPʂJE^[
	tim_10ms = 0;										// PbPʂJE^[
	tim_10ms_led1 = 0;									// kdcPpPOrPʃ^C}[
	tim_10ms_led2 = 0;									// kdcQpPOrPʃ^C}[
	tim_1sec_clk = 0;
	tim_1min_clk = 0;
	tim_1hou_clk = 0;

}
//*****************************************
// Timer2 Close
//  Timer2 ̎gp߂
//*****************************************
void	Timer2_close(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = 0;											// Dont Output Timer2 Signal
	TIMSK2 = 0;											// Interrupt Disable

}
//***************************
// Timer2 Comper Match A Interrupt
//
//  10mS 
//***************************
ISR	(TIMER2_COMPA_vect)	
{
	tim_10ms++;
	if(100 <= tim_10ms){					// Pbo
		tim_10ms = 0;
		tim_1sec_clk++;
		if(60 <= tim_1sec_clk){
			tim_1sec_clk = 0;
			tim_1min_clk++;
			if(60 <= tim_1min_clk){
				tim_1min_clk = 0;
				tim_1hou_clk++;
				if(100 <= tim_1hou_clk){
					tim_1hou_clk = 0;
				}
			}
		}
	}

	if(tim_10ms_led1 != 0){
		tim_10ms_led1--;					// kdcPpPOrPʃ^C}[@|P
	}

	if(tim_10ms_led2 != 0){
		tim_10ms_led2--;					// kdcQpPOrPʃ^C}[@|P
	}

	sw_in();
}

