//***************************************************************************************
// Graphic LCD Serial(RS232) Terminal Program ATMega88
// CPU Clock:O9.216MHz(9.22)i3.3VPOlgȉȂ̂ł̂܂܂Ŏgj
//   iq[Yf[^@WȂŁAOUWlgȏɂj
//
//	File name: switch.c
//
//  2014/03/28 New
//***************************************************************************************

#include	<avr/io.h>
#include	 "switch.h"



//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++ XCb`
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// SW ON
unsigned char	gIn_Left;			// []
unsigned char	gIn_Sift;			// [SIFT]
unsigned char	gIn_Right;			// [E]
unsigned char	gIn_Enter;			// [ENTER]

// SW ON One Time
unsigned char	gOn_Left;			// []
unsigned char	gOn_Sift;			// [SIFT]
unsigned char	gOn_Right;			// [E]
unsigned char	gOn_Enter;			// [ENTER]

// SW OFF One Time
unsigned char	gOff_Left;			// []
unsigned char	gOff_Sift;			// [SIFT]
unsigned char	gOff_Right;			// [E]
unsigned char	gOff_Enter;			// [ENTER]

//***************************************************************************************
//	SW PORT(PB) ݒ
//***************************************************************************************
void sw_init(void)
{
	DDRB &= ~((1 << DDB0) | (1 << DDB1) | (1 << DDB2));	// Port-B Bit0,1,2 : Input
	PORTB |= ( (1 << PB0) | (1 << PB1) | (1 << PB2) );	// Port-B Bit0,1,2 : Pullup
	DDRD &= ~(1 << DDD7);								// Port-D Bit7 : Input
	PORTD |= (1 << PD7);								// Port-D Bit7 : Pullup
}
//***************************************************************************************
//	on_xxx Flag clear
//***************************************************************************************/
void on_sw_clr(void)
{
	gOn_Left = 0;			// []
	gOn_Sift = 0;			// [SIFT]
	gOn_Right = 0;			// [E]
	gOn_Enter = 0;			// [ENTER]

	gOff_Left = 0;			// []
	gOff_Sift = 0;			// [SIFT]
	gOff_Right = 0;			// [E]
	gOff_Enter = 0;			// [ENTER]
}
//***************************************************************************************
//	SW PORT(PB) check = 10ms
//@@POr荞݂ŌĂ΂
//***************************************************************************************
void sw_in(void)
{
//	#define	S_LEFT		0x01				// PB0
	#define	K_RIGHT		0x01				// PB0
//	#define	S_CENTER	0x02				// PB1
	#define	K_SIFT		0x02				// PB1
//	#define	S_RIGHT		0x04				// PB2
	#define	K_ENTER		0x04				// PB2
//	#define	S_DOWN		0x80				// PD7
	#define	K_LEFT		0x80				// PD7
	static	unsigned char	port_num=0;
	static	unsigned char	port_b[4]={0,0,0,0};
	unsigned char			pob;
	static	unsigned char	port_d[4]={0,0,0,0};
	unsigned char			pod;

	port_b[port_num]= ~PINB;
	port_d[port_num]= ~PIND;
	port_num++;
	port_num &= 0x03;

	pob = port_b[0] | port_b[1] | port_b[2] | port_b[3];		// Active High
	pod = port_d[0] | port_d[1] | port_d[2] | port_d[3];		// Active High
	
	if ((pod & K_LEFT) != 0) {				// [LEFT]
		if (gIn_Left == OFF) {				// ܂łnee
			gOn_Left = ON;
		}
		gIn_Left = ON;
	} else {
		if (gIn_Left == ON) {				// ܂łnm
			gOff_Left = ON;
		}
		gIn_Left = OFF;
	}

	if ((pob & K_ENTER) != 0) {				// [ENTER]
		if (gIn_Enter == OFF) {				// ܂łnee
			gOn_Enter = ON;
		}
		gIn_Enter = ON;
	} else {
		if (gIn_Enter == ON) {				// ܂łnm
			gOff_Enter = ON;
		}
		gIn_Enter = OFF;
	}
	
	if ((pob & K_RIGHT) != 0) {				// [RIGHT]
		if (gIn_Right == OFF) {				// ܂łnee
			gOn_Right = ON;
		}
		gIn_Right = ON;
	} else {
		if (gIn_Right == ON) {				// ܂łnm
			gOff_Right = ON;
		}
		gIn_Right = OFF;
	}

	if ((pob & K_SIFT) != 0) {				// [SIFT]
		if (gIn_Sift == OFF) {				// ܂łnee
			gOn_Sift = ON;
		}
		gIn_Sift = ON;
	} else {
		if (gIn_Sift == ON) {				// ܂łnm
			gOff_Sift = ON;
		}
		gIn_Sift = OFF;
	}
}	
